localDatabase = undefined;
function createDatabaseInstance() {		//占用挺多内存的
	if (deviceInfo.device !== 'android') {
		localDatabase = window.sqlitePlugin.openDatabase({
			name: 'smloft',
			location: 'default',
			androidDatabaseProvider: 'system'
		});
	} else {
		localDatabase = window.openDatabase("smloft", "1.0", "smloft database", 10000000);	//open 10mb database
	}
}
document.addEventListener("deviceready", function() {
	createDatabaseInstance();
});

function doQuery(sql, escapeValueArr, callback){
	//console.log(sql);
	var result;
	if (escapeValueArr == undefined || escapeValueArr == null) escapeValueArr = [];
	localDatabase.transaction(function(tx) {
		tx.executeSql(sql, escapeValueArr, function (tx, doQueryResults) {
			//console.log("Returned rows = " + doQueryResults.rows.length);
			if (sql.indexOf("INSERT") == 0 || sql.indexOf("insert") == 0){	//return new id for insert
				if (doQueryResults.insertId != undefined) {
					result = doQueryResults.insertId;
				} else {
					//no id returned
					result = true;
				}
			} else if (sql.indexOf("UPDATE") == 0 || sql.indexOf("update") == 0) {	//return rows affect for update
				if (doQueryResults.rowsAffected == undefined) {		//the situation of no ID
					if (doQueryResults.rows != undefined) {
						result = true;
					} else {
						result = null;
					}
				} else {
					result = doQueryResults.rowsAffected;
				}
			} else if (sql.indexOf("SELECT") == 0 || sql.indexOf("select") == 0) {	//return rows for select
				//console.log(sql + "=>" + doQueryResults.rows.length);
				if (doQueryResults.rows.length <= 0) {
					result = null;
				} else {
					//console.log("yes");
					result = new Array();
					var len = doQueryResults.rows.length;
			        for (var i = 0; i < len; i++){
			        	result.push(doQueryResults.rows.item(i));
			        }
			        //console.log(result[0].uuid);
					//result = doQueryResults.rows;
					//console.log(sql + "=>" + doQueryResults.rows.length);
				}
			} else {
				result = doQueryResults.rows;
			}
			//console.log("doQuery Result for sql: " + sql);
			//console.log(result);
		});
	}, function (err) {
		console.log("Error processing SQL: " + sql + "- " + err.message);
		if ((typeof callback) == "function") callback(null);
	}, function(){
		//console.log("数据库执行成功'" + sql + "',正在执行回馈");
		if ((typeof callback) == "function") callback(result);
	});
}

function createSchema(myPrevSetting, callback){
	//doQuery("CREATE TABLE IF NOT EXISTS cate (id INTEGER PRIMARY KEY, uid INTEGER, theme_id INTEGER, name TEXT, title_pic TEXT, owner INTEGER, is_playable INTEGER, type INTEGER, pic_num INTEGER, video_num INTEGER, viewed_num INTEGER, `order` INTEGER)", null, function(){
	doQuery("CREATE TABLE IF NOT EXISTS how_to_use (profile_hide_content INTEGER, video_layer INTEGER, video_list INTEGER, home_slide INTEGER)", null, function(){
		doQuery("CREATE TABLE IF NOT EXISTS video_chunk (tid INTEGER, quality TEXT, byte_from INTEGER, byte_end INTEGER, downloading INTEGER, downloaded INTEGER)", null, function(){
			doQuery("CREATE TABLE IF NOT EXISTS downloading_videos (tid INTEGER, quality TEXT, title TEXT, content TEXT, thumb TEXT, url TEXT, size_bytes INTEGER, loaded_bytes INTEGER, percentage DECIMAL(6,1))", null, function(){
				doQuery("CREATE TABLE IF NOT EXISTS downloaded_videos (id INTEGER PRIMARY KEY, tid INTEGER, quality TEXT, file TEXT, title TEXT, content TEXT, image TEXT)", null, function(){
					doQuery("CREATE TABLE IF NOT EXISTS local_images (id INTEGER PRIMARY KEY, fullpath TEXT)", null, function(){
						doQuery("CREATE TABLE IF NOT EXISTS stop_prompt (id INTEGER PRIMARY KEY, night_mode INTEGER)", null, function(){
							doQuery("CREATE TABLE IF NOT EXISTS personal (id INTEGER PRIMARY KEY, uid, username, password, plain_password, uuid, active_url, money INT, diamond INT, photo, privacy INT, email, phone, viewed_pic_ids TEXT, video_ids TEXT, search_source_type TEXT, loading_time DECIMAL(6,2), version INT, old_user INT, unix_vip_end_time INTEGER, unix_gold_vip_end_time INTEGER, unix_diamond_vip_end_time INTEGER, vip_cash, vip_gold, currency, bonus, avatar, theme_id INTEGER, payment_gateway_url TEXT, email_verified INT, no_local_image INT, is_tmp INT, last_update_cate_time INTEGER, use_default_player INTEGER, hide_appstore_related INTEGER, preferred_lang, only_show_translated_en INTEGER, export_db_time, night_mode INTEGER)", null, function(){
								doQuery("SELECT id FROM personal", null, function(personalRows){
									if (personalRows == null || personalRows == undefined || personalRows.length <= 0){
										//doQuery("INSERT INTO personal (old_user, email, plain_password, privacy, version) VALUES (0, '', '', 1, " + dbVersion + ")", null, function(){});
										if (myPrevSetting == null || myPrevSetting == undefined || myPrevSetting.length <= 0 || myPrevSetting.uid == undefined || myPrevSetting.uid == null) {		//全新用户
											doQuery("INSERT INTO personal (old_user, email, plain_password, privacy, version, use_default_player) VALUES (0, '', '', 1, " + dbVersion + ", 0)", null, function(){});
										} else {		//之前有personal数据, 因为数据库版本更新要将原有数据插入新表
											//console.log('之前有personal数据, 因为数据库版本更新要将原有数据插入新表');
											if (parseInt(myPrevSetting.last_update_cate_time, 10) > 0) {
												var myPrevLastUpdateCateTime = myPrevSetting.last_update_cate_time;
											} else {
												var myPrevLastUpdateCateTime = 0;
											}
											if (parseInt(myPrevSetting.use_default_player, 10) === 1) {
												var myPrevUseDefaultPlayer = 1;
											} else {
												var myPrevUseDefaultPlayer = 0;
											}
											if (parseInt(myPrevSetting.night_mode, 10) === 1) {
												var myPrevNightMode = 1;
											} else {
												var myPrevNightMode = 0;
											}
											doQuery("INSERT INTO personal (uid, username, password, plain_password, uuid, version, old_user, is_tmp, last_update_cate_time, use_default_player, hide_appstore_related, preferred_lang, night_mode) VALUES ('" + myPrevSetting.uid + "', '" + myPrevSetting.username + "', '" + myPrevSetting.password + "', '" + myPrevSetting.plain_password + "', '" + myPrevSetting.uuid + "', " + dbVersion + ", 0, " + myPrevSetting.is_tmp + ", " + myPrevLastUpdateCateTime + ", " + myPrevUseDefaultPlayer + ", " + myPrevSetting.hide_appstore_related + ", '" + myPrevSetting.preferred_lang + "', " + myPrevNightMode + ")", null, function(){});
										}
									}
									doQuery("CREATE TABLE IF NOT EXISTS info (id INTEGER PRIMARY KEY, title, content, time)", null, function(){
										doQuery("SELECT id FROM info", null, function(infoRows){
											if (infoRows == null || infoRows == undefined || infoRows.length <= 0){
												doQuery("INSERT INTO info (title) VALUES ('')", null, function(){});
											}
											
											doQuery("CREATE TABLE IF NOT EXISTS themes (id INTEGER PRIMARY KEY, cn_name TEXT, description TEXT, logo TEXT, url TEXT, is_public INTEGER, enable INTEGER, bbs_url TEXT, is_gallery INTEGER, is_vod INTEGER, is_live INTEGER, picture_num INTEGER, video_num INTEGER, live_num INTEGER)", null, function(){
												if ((typeof callback) == "function") callback();
											});
										});
									});
								});
							});
						});
					});
				});
			});
		});
	});
	//});
}

function deleteAllTable(callback) {
	doQuery("DROP TABLE how_to_use", null, function(){
		doQuery("DROP TABLE video_chunk", null, function(){
			doQuery("DROP TABLE downloading_videos", null, function(){
				doQuery("DROP TABLE downloaded_videos", null, function(){
					doQuery("DROP TABLE local_images", null, function(){
						doQuery("DROP TABLE personal", null, function(){
							doQuery("DROP TABLE info", null, function(){
								doQuery("DROP TABLE themes", null, function(){
									if ((typeof callback) == "function") callback();
								});
							});
						});
					});
				});
			});
		});
	});	
}

function deleteSchema(callback){
	doQuery("DROP TABLE stop_prompt", null, function(){
	doQuery("DROP TABLE video_chunk", null, function(){
	doQuery("DROP TABLE how_to_use", null, function(){
	//doQuery("DROP TABLE downloading_videos", null, function(){
	doQuery("DROP TABLE cate", null, function(){
		//doQuery("DROP TABLE local_images", null, function(){
			//doQuery("DROP TABLE info", null, function(){
				doQuery("DROP TABLE cate_statistics", null, function(){
					doQuery("DROP TABLE non_cate_statistics", null, function(){
						doQuery("DROP TABLE html_templates", null, function(){
							//doQuery("DROP TABLE themes", null, function(){
								//personal表要单独处理, 将原来的personal里的登陆信息取出来, 删除旧表, 创建新表, 立即把旧表的登陆数据放入新表
								loadSetting(function(myPrevSetting){
									if (myPrevSetting == null || myPrevSetting == undefined || myPrevSetting.uid == undefined || myPrevSetting.uid == null) {	//如果是全新用户, 之前都没有personal, 那么myPrevSetting的值是空数组{}
										myPrevSetting = null;
									}
									doQuery("DROP TABLE personal", null, function(){
										//console.log("Wooh, 我们删除了所有数据库表" + (myPrevSetting != null?'但保留了你的登陆信息':''));
										if ((typeof callback) == "function") callback(myPrevSetting);
									});
								});
							//});
						});
					});
				});
			//});
		//});
	});
	});
	//});
	
	});
	});
}

function initDatabase(callback) {
	doQuery("SELECT version FROM personal", null, function(rows){
		if (rows == null || rows == undefined || rows.length <= 0){
			//console.log("数据库不存在");
			deleteSchema(function(myPrevSetting) {
				createSchema(myPrevSetting, function(){
					if ((typeof callback) == "function") callback();
				});
			});
		} else if (rows != undefined && rows != null && rows.length && parseInt(rows[0]["version"], 10) != dbVersion) {
			//console.log("数据库版本不符");
			deleteSchema(function(myPrevSetting) {
				createSchema(myPrevSetting, function(){
					if ((typeof callback) == "function") callback();
				});
			});
		} else {
			if ((typeof callback) == "function") callback();
		}
	});
	
}

function getTableRows(tableName, whereSql, options, callback) {
	var sql = 'SELECT * FROM ' + tableName + ' ';
	if (isValidStr(whereSql)) {
		sql += ' WHERE ' + whereSql;
	}
	doQuery(sql, null, function(rows) {
		var returnData;
		if (rows != null && rows != undefined) {
			returnData = new Array();
			for (var i in rows) {
				if (options != undefined) {
					
				}
				if (isValidStr(whereSql) && whereSql.indexOf(' id = ') != -1) {
					returnData = new Object();
					returnData = rows[i];
					break;
				} else {
					returnData.push(rows[i]);
				}
			}
			
			callback(returnData);
		} else {
			callback(null);
		}
	});
}

function updateTable(tableName, whereSql, updateData, options, callback) {
	if (whereSql == undefined) {
		alert('程序错误：updateTableRows没有传递whereSql');
		if ((typeof callback) == "function") callback(null);
		return false;
	}
	if (updateData == undefined) {
		alert('程序错误：updateTableRows没有传递updateData');
		if ((typeof callback) == "function") callback(null);
		return false;
	}
	var sql = 'SELECT 1 FROM ' + tableName + ' WHERE ' + whereSql;
	doQuery(sql, null, function(result){
		if (result != undefined && result != null && result.length > 0) {		//该行已存在，update
			var sqlArr = [];
			for (var fieldName in updateData) {
				if (typeof updateData[fieldName] == 'string') {
					updateData[fieldName] = updateData[fieldName].replace(/"/g, "'");
				}
				sqlArr.push('`' + fieldName + '` = "' + updateData[fieldName] + '"');
			}
			var setSql = sqlArr.join(', ');
			var sql = 'UPDATE ' + tableName + ' SET ' + setSql + ' WHERE ' + whereSql;
			doQuery(sql, null, function(result){
				if ((typeof callback) == "function") callback(true);
			});
		} else {		//该行不存在，insert
			//INSERT INTO personal (uid, username) VALUES ("", "")
			var insertSqlPart1Arr = new Array();
			var insertSqlPart2Arr = new Array();
			for (var fieldName in updateData) {
				if (typeof updateData[fieldName] == 'string') {
					updateData[fieldName] = updateData[fieldName].replace(/"/g, "'");
				}
				insertSqlPart1Arr.push('`' + fieldName + '`');
				if (updateData[fieldName] != undefined && updateData[fieldName] != null) {
					insertSqlPart2Arr.push('"' + updateData[fieldName] + '"');
				} else {
					insertSqlPart2Arr.push('""');
				}
			}
			var insertSqlPart1Str = insertSqlPart1Arr.join(', ');
			var insertSqlPart2Str = insertSqlPart2Arr.join(', ');
			var sql = 'INSERT INTO ' + tableName + ' (' + insertSqlPart1Str + ') VALUES (' + insertSqlPart2Str + ')';
			//console.log(sql);
			doQuery(sql, null, function(id){
				if ((typeof callback) == "function") callback(id);
			});
		}
	});
}

function delTableRows(tableName, whereSql, callback) {
	var sql = 'DELETE FROM ' + tableName + ' WHERE ' + whereSql + '';
	doQuery(sql, null, function(result){
		if ((typeof callback) == "function") callback(true);
	});
}

function saveSetting(data, callback){
	var sqlArr = [];
	for (var fieldName in data) {
		//alert(fieldName + ": " + (typeof data[fieldName]));
		sqlArr.push(fieldName + " = '" + data[fieldName] + "'");
	}
	if (sqlArr.length) {
		var sql = sqlArr.join(", ");
		doQuery("UPDATE personal SET " + sql + " WHERE id != 0", null, function(result){
			if ((typeof callback) == "function") callback(result);
		});
	} else {
		if ((typeof callback) == "function") callback(false);
	}
}

function loadSetting(callback) {
	doQuery("SELECT * FROM personal LIMIT 1", null, function(personalRows){
		var returnObj = new Object();
		if (personalRows != null && personalRows != undefined && personalRows.length > 0){
			//returnObj = personalRows[0];
			returnObj = jQuery.extend(true, {}, personalRows[0]);		//必须使用jQuery的deep copy方式完全复制personalRows[0]给returnObj。不然returnObj仅仅是指向personalRows[0]的reference，而某些版本的操作系统无法修改来自数据库的personalRows[0]的值
			for (var fieldName in returnObj) {
				if (returnObj[fieldName] == 'undefined' || returnObj[fieldName] == 'null') {
					returnObj[fieldName] = undefined;
				}
			}
		}
		callback(returnObj);
	});
}

function saveViewedPicId(id, callback, refillPicIds){
	if (refillPicIds != undefined) {
		doQuery("UPDATE personal SET viewed_pic_ids = '" + refillPicIds + "' WHERE id != 0", null, function(result){
			if ((typeof callback) == "function") callback(result);
		});
	} else {
		if (id == undefined || id == null || id == "" || id == "undefined") return false;
		loadViewedPicId(function(savedPicIdArr){
			var newPicIDStr = undefined;
			if (savedPicIdArr != null && savedPicIdArr != undefined) {
				//clear invalid id value
				savedPicIdArr = savedPicIdArr.slice(-100);				//100张之前的图片就不保留了, 提高程序运行速度
				var alreadySavedFlag = 0;
				for (var i in savedPicIdArr) {
					if (savedPicIdArr[i] != "undefined" && savedPicIdArr[i] != undefined && savedPicIdArr[i] != null && savedPicIdArr[i] != "" && parseInt(savedPicIdArr[i], 10) > 0){
						if (savedPicIdArr[i] == id){
							alreadySavedFlag = 1;
						}
					} else {
						savedPicIdArr.splice(i, 1);
					}
				}
				
				if (alreadySavedFlag) {
					if ((typeof callback) == "function") callback(null);
				} else {
					savedPicIdArr.push(id);
					newPicIDStr = savedPicIdArr.join(",");
					doQuery("UPDATE personal SET viewed_pic_ids = '" + newPicIDStr + "' WHERE id != 0", null, function(result){
						if ((typeof callback) == "function") callback(true);
					});
				}
				
			} else {
				doQuery("UPDATE personal SET viewed_pic_ids = '" + id + "' WHERE id != 0", null, function(result){
					if ((typeof callback) == "function") callback(true);
				});
			}
		});
	}
	
}


function loadViewedPicId(callback) {
	doQuery("SELECT viewed_pic_ids FROM personal LIMIT 1", null, function(picIdRows){
		var picIdStr = undefined;
		var result;
		if (picIdRows != null && picIdRows != undefined && picIdRows.length > 0 && picIdRows[0].viewed_pic_ids != "" && picIdRows[0].viewed_pic_ids != null && picIdRows[0].viewed_pic_ids != undefined && picIdRows[0].viewed_pic_ids != "undefine"){
			picIdStr = picIdRows[0].viewed_pic_ids;
		}
		if (picIdStr != undefined && picIdStr != null && picIdStr != ""){
			result = picIdStr.split(",");
		} else {
			result = null;
		}
		callback(result);
	});
}

function saveInfo(infoObj, callback){
	doQuery("UPDATE info SET title = \"" + infoObj.title + "\", content = \"" + infoObj.content + "\", time = \"" + infoObj.time + "\"  WHERE id != 0", null, function(result){
		if ((typeof callback) == "function") callback(result);
	});
}

function loadInfo(callback){
	doQuery("SELECT * FROM info LIMIT 1", null, function(infoRows){
		var returnObj = new Object();
		returnObj.title = returnObj.content = returnObj.time = undefined;
		if (infoRows != null && infoRows != undefined && infoRows.length > 0 && infoRows[0].title && infoRows[0].content){
			returnObj.title = infoRows[0].title;
			returnObj.content = infoRows[0].content;
			returnObj.time = infoRows[0].time;
		}
		if (returnObj.title == "undefined") returnObj.title = undefined;
		if (returnObj.content == "undefined") returnObj.content = undefined;
		if (returnObj.time == "undefined") returnObj.time = undefined;
		callback(returnObj);
	});
}


function saveMoney(money, callback){
	doQuery("UPDATE personal SET money = " + money + " WHERE id != 0", null, function(result){
		if ((typeof callback) == "function") callback(result);
	});
}

function loadMoney(callback){
	doQuery("SELECT money FROM personal LIMIT 1", null, function(moneyRows){
		var savedMoney = null;
		if (moneyRows != null && moneyRows != undefined && moneyRows.length > 0 && moneyRows[0].money != "" && moneyRows[0].money != null && moneyRows[0].money != undefined && moneyRows[0].money != "undefine"){
			savedMoney = moneyRows[0].money;
		}
		callback(savedMoney);
	})
}

function saveDiamond(diamond, callback){
	doQuery("UPDATE personal SET diamond = " + diamond + " WHERE id != 0", null, function(result){
		if ((typeof callback) == "function") callback(result);
	});
}

function loadDiamond(callback){
	doQuery("SELECT diamond FROM personal LIMIT 1", null, function(diamondRows){
		var savedDiamond = null;
		if (diamondRows != null && diamondRows != undefined && diamondRows.length > 0 && diamondRows[0].diamond != "" && diamondRows[0].diamond != null && diamondRows[0].diamond != undefined && diamondRows[0].diamond != "undefine"){
			savedDiamond = diamondRows[0].diamond;
		}
		callback(savedDiamond);
	})
}

function saveVideoId(videoIDs, callback){		//notice: uuid and uid are in different terms. uuid is device id, uid is database id for table users
	doQuery("UPDATE personal SET video_ids = '" + videoIDs + "' WHERE id != 0", null, function(result){
		if ((typeof callback) == "function") callback(result);
	});
}

function loadVideoId(callback){
	doQuery("SELECT video_ids FROM personal LIMIT 1", null, function(vidRows){
		var savedVid = null;
		if (vidRows != null && vidRows != undefined && vidRows.length > 0 && vidRows[0].savedVid != "" && vidRows[0].savedVid != null && vidRows[0].savedVid != undefined && vidRows[0].savedVid != "undefine"){
			savedVid = vidRows[0].savedVid;
		}
		callback(savedVid);
	})
}

function saveLoadingTime(loadingTime, callback){		//loadingTime is decimal 6,2
	//console.log("即将保存的时间是: " + loadingTime);
	if (loadingTime == undefined || loadingTime == null) {
		loadingTime = 0.00;
	}
	doQuery("UPDATE personal SET loading_time = " + loadingTime + " WHERE id != 0", null, function(result){
		if ((typeof callback) == "function") callback(result);
	});
}

function loadLoadingTime(callback){
	doQuery("SELECT loading_time FROM personal WHERE id != 0", null, function(ltRows){
		var thisLTTime = 0.00;
		if (ltRows != null && ltRows != undefined && ltRows.length > 0 && ltRows[0].loading_time != undefined && ltRows[0].loading_time != null){
			thisLTTime = ltRows[0].loading_time;
		}
		callback(thisLTTime);
	})
}


function saveActiveURL(l_url, callback){
	if (isValidStr(l_url)) {
		doQuery('UPDATE personal SET `active_url` = "' + l_url + '" WHERE id = 1', null, function(result){
			if ((typeof callback) == 'function') callback(result);
		});
	}
}

function loadActiveURL(callback){
	doQuery("SELECT active_url FROM personal LIMIT 1", null, function(activeURLRows){
		var l_active_url = undefined;
		if (activeURLRows != null && activeURLRows != undefined && activeURLRows.length > 0 && activeURLRows[0].active_url != "" && activeURLRows[0].active_url != null && activeURLRows[0].active_url != undefined && activeURLRows[0].active_url != "undefine"){
			l_active_url = activeURLRows[0].active_url;
		}
		callback(l_active_url);
	});
}

function loadSearchSourceType(callback){
	doQuery("SELECT search_source_type FROM personal LIMIT 1", null, function(sourceTypeRows){
		var sourceType = undefined;
		if (sourceTypeRows != null && sourceTypeRows != undefined && sourceTypeRows.length > 0 && isValidStr(sourceTypeRows[0].search_source_type)){
			sourceType = sourceTypeRows[0].search_source_type;
		}
		callback(sourceType);
	});
}

function addTheme(themeData, callback) {
	if (themeData != undefined && themeData.id != undefined) {
		var sql = 'INSERT INTO themes (id, cn_name, description, logo, url, is_public, enable, bbs_url, is_gallery, is_vod, is_live, picture_num, video_num, live_num) VALUES (' + themeData.id + ', "' + themeData.cn_name + '", "' + (themeData.description != undefined?themeData.description:'') + '", "' + (themeData.logo != undefined?themeData.logo:'') + '", "' + (themeData.url != undefined?themeData.url:'') + '", ' + (themeData.is_public != undefined?themeData.is_public:'0') + ', ' + (themeData.enable != undefined?themeData.enable:'0') + ', "' + (themeData.bbs_url != undefined?themeData.bbs_url:'') + '", ' + (themeData.is_gallery != undefined?themeData.is_gallery:'0') + ', ' + (themeData.is_vod != undefined?themeData.is_vod:'0') + ', ' + (themeData.is_live != undefined?themeData.is_live:'0') + ', ' + (themeData.picture_num != undefined?themeData.picture_num:'0') + ', ' + (themeData.video_num != undefined?themeData.video_num:'0') + ', ' + (themeData.live_num != undefined?themeData.live_num:'0') + ')';
		doQuery(sql, null, function(id){
			if ((typeof callback) == "function") callback(id);
		});
	}
}

function updateTheme(themeData, callback){
	if (themeData != undefined && themeData.id != undefined) {
		var checkSql = 'SELECT 1 FROM themes WHERE id = ' + themeData.id + ' LIMIT 1';
		doQuery(checkSql, null, function(checkResult){
			if (checkResult == null) {
				addTheme(themeData, callback);
			} else {
				if (!isValidStr(themeData.bbs_url)) themeData.bbs_url = '';
				var sql = 'UPDATE themes SET cn_name = "' + themeData.cn_name + '", description = "' + (themeData.description != undefined?themeData.description:'') + '", logo = "' + (themeData.logo != undefined?themeData.logo:'') + '", url = "' + (themeData.url != undefined?themeData.url:'') + '", is_public = ' + (themeData.is_public != undefined?themeData.is_public:'0') + ', enable = ' + (themeData.enable != undefined?themeData.enable:'0') + ', bbs_url = "' + (themeData.bbs_url != undefined?themeData.bbs_url:'') + '", is_gallery = ' + (themeData.is_gallery != undefined?themeData.is_gallery:'0') + ', is_vod = ' + (themeData.is_vod != undefined?themeData.is_vod:'0') + ', is_live = ' + (themeData.is_live != undefined?themeData.is_live:'0') + ', picture_num = ' + (themeData.picture_num != undefined?themeData.picture_num:'0') + ', video_num = ' + (themeData.video_num != undefined?themeData.video_num:'0') + ', live_num = ' + (themeData.live_num != undefined?themeData.live_num:'0') + ' WHERE id = ' + themeData.id + '';
				doQuery(sql, null, function(){
					if ((typeof callback) == "function") callback(themeData);
				});
			}
		});
	}
}

function getThemes(limit, page, callback) {
	var limitSql = '';
	if (limit != undefined && page != undefined) {
		limitSql += ' LIMIT ' + (limit * (page - 1)) + ', ' + limit + ' ';
	}
	var sql = 'SELECT * FROM themes ORDER BY id ASC' + limitSql;
	var sqlNum = 'SELECT 1 FROM themes ';
	doQuery(sql, null, function(result){
		doQuery(sqlNum, null, function(resultNum) {
			var num = 0;
			if (resultNum && resultNum != null) {
				num = resultNum.length;
			}
			var more = false;
			var showing_num = limit * page;
			if (showing_num < num) more = true;
			callback(result, num, more);
		});
		
	})
}

function getTheme(id, callback) {
	var sql = 'SELECT * FROM themes WHERE id = ' + id;
	doQuery(sql, null, function(result){
		if (result != undefined && result != null && result.length > 0) {
			callback(result[0]);
		} else {
			callback(null);
		}
		
	});
}

function addDownloadedVideo(videoData, callback) {
	var checkSql = 'SELECT 1 FROM downloaded_videos WHERE tid = ' + videoData.tid + ' AND quality = "' + videoData.quality + '" LIMIT 1';
	doQuery(checkSql, null, function(checkResult){
		if (checkResult == null) {
			if (deviceInfo.device !== 'android') {
				if (isValidStr(videoData.image)) {
					videoData.image = videoData.image.substring(videoData.image.lastIndexOf('/') + 1);
				} else {
					videoData.image = '';
				}
				if (isValidStr(videoData.file)) {
					videoData.file = videoData.file.substring(videoData.file.lastIndexOf('/') + 1);
				} else {
					videoData.file = '';
				}
			}
			videoData.title = videoData.title.replace(/\"/g, "'");
			videoData.content = videoData.content.replace(/\"/g, "'");
			var sql = 'INSERT INTO downloaded_videos (tid, quality, file, title, content, image) VALUES (' + videoData.tid + ', "' + videoData.quality + '", "' + videoData.file + '", "' + videoData.title + '", "' + videoData.content + '", "' + videoData.image + '")';
			doQuery(sql, null, function(id){
				if ((typeof callback) == "function") callback(id);
			});
		} else {
			
		}
	});
}

function deleteDownloadedVideo(id, tid, callback) {
	var sql = 'DELETE FROM downloaded_videos WHERE id = ' + id + '';
	if (tid != undefined) {
		sql = 'DELETE FROM downloaded_videos WHERE tid = ' + tid + '';
	}
	if (id == undefined && tid == undefined) {
		sql = 'DELETE FROM downloaded_videos WHERE id != 0';
	}
	doQuery(sql, null, function(result){
		if ((typeof callback) == "function") callback(result);
	});
}

function getDownloadedVideo(id, tid, limit, page, callback) {		//page start from 1
	var limitSql = '';
	if (limit != undefined && page != undefined) {
		limitSql += ' LIMIT ' + (limit * (page - 1)) + ', ' + limit + ' ';
	}
	var where = '';
	var sql = 'SELECT * FROM downloaded_videos ';
	var sqlNum = 'SELECT 1 FROM downloaded_videos ';
	if (tid != undefined) {
		where += ' WHERE tid = ' + tid + ' ';
	} else if (id != undefined) {
		where += ' WHERE id = ' + id + ' ';
	}
	sql += where + ' ORDER BY id DESC' + limitSql;
	sqlNum += where;
	doQuery(sql, null, function(result) {
		doQuery(sqlNum, null, function(resultNum) {
			var num = 0;
			if (resultNum && resultNum != null) {
				num = resultNum.length;
			}
			var more = false;
			var showing_num = limit * page;
			if (showing_num < num) more = true;
			callback(result, num, more);
		});
	});
}

function fixIOSPathQuirk(path) {
	if (deviceInfo.device !== 'android') {		//ios有个和android不一样的地方，它的本地路径在每次升级app以后会换，所以对ios只保留文件名就好了
		if (path.indexOf('/') === -1) {
			return deviceVideoFullPath + path;
		} else {
			if (path.indexOf(deviceVideoFullPath) === -1) {
				return deviceVideoFullPath + path.substring(path.lastIndexOf('/') + 1);
			} else {
				return path;
			}
		}
	} else {
		return path;
	}
}


function saveVIPEndTime(unixVIPEndTime, callback){
	if (unixVIPEndTime === false) unixVIPEndTime = 0;
	doQuery("UPDATE personal SET unix_vip_end_time = " + unixVIPEndTime + " WHERE id != 0", null, function(result){
		if ((typeof callback) == "function") callback(result);
	});
}

function loadVIPEndTime(callback){
	doQuery("SELECT unix_vip_end_time FROM personal LIMIT 1", null, function(resultRows){
		var unixVIPEndTime = null;
		if (resultRows != null && resultRows != undefined && resultRows.length > 0 && resultRows[0].unix_vip_end_time != "" && resultRows[0].unix_vip_end_time != null && resultRows[0].unix_vip_end_time != undefined && resultRows[0].unix_vip_end_time != "undefine"){
			unixVIPEndTime = resultRows[0].unix_vip_end_time;
		}
		callback(unixVIPEndTime);
	});
}

function saveGoldVIPEndTime(unixGoldVIPEndTime, callback){
	if (unixGoldVIPEndTime === false) unixGoldVIPEndTime = 0;
	doQuery("UPDATE personal SET unix_gold_vip_end_time = " + unixGoldVIPEndTime + " WHERE id != 0", null, function(result){
		if ((typeof callback) == "function") callback(result);
	});
}

function loadGoldVIPEndTime(callback){
	doQuery("SELECT unix_gold_vip_end_time FROM personal LIMIT 1", null, function(resultRows){
		var unixGoldVIPEndTime = null;
		if (resultRows != null && resultRows != undefined && resultRows.length > 0 && resultRows[0].unix_gold_vip_end_time != "" && resultRows[0].unix_gold_vip_end_time != null && resultRows[0].unix_gold_vip_end_time != undefined && resultRows[0].unix_gold_vip_end_time != "undefine"){
			unixGoldVIPEndTime = resultRows[0].unix_gold_vip_end_time;
		}
		callback(unixGoldVIPEndTime);
	});
}

function saveDiamondVIPEndTime(unixDiamondVIPEndTime, callback){
	if (unixDiamondVIPEndTime === false) unixDiamondVIPEndTime = 0;
	doQuery("UPDATE personal SET unix_diamond_vip_end_time = " + unixDiamondVIPEndTime + " WHERE id != 0", null, function(result){
		if ((typeof callback) == "function") callback(result);
	});
}

function loadDiamondVIPEndTime(callback){
	doQuery("SELECT unix_diamond_vip_end_time FROM personal LIMIT 1", null, function(resultRows){
		var unixDiamondVIPEndTime = null;
		if (resultRows != null && resultRows != undefined && resultRows.length > 0 && resultRows[0].unix_diamond_vip_end_time != "" && resultRows[0].unix_diamond_vip_end_time != null && resultRows[0].unix_diamond_vip_end_time != undefined && resultRows[0].unix_diamond_vip_end_time != "undefine"){
			unixDiamondVIPEndTime = resultRows[0].unix_diamond_vip_end_time;
		}
		callback(unixDiamondVIPEndTime);
	});
}




function updateVideoChunk(tid, quality, byteTotal, byteFrom, byteEnd, downloading, isDownloaded, callback) {
	var noMoreNext = false;
	if (byteEnd >= byteTotal) {
		noMoreNext = true;
		byteEnd = byteTotal;
	}
	var where = ' tid = ' + tid + ' AND quality = "' + quality + '" AND byte_from = ' + byteFrom + ' AND byte_end = ' + byteEnd + '';
	var sql = 'SELECT * FROM video_chunk WHERE ' + where + '';
	//console.log('UPDATE: byteFrom ' + byteFrom + ' - byteEnd ' + byteEnd);
	doQuery(sql, null, function(resultRows) {
		if (resultRows != null && resultRows != undefined && resultRows.length > 0) {
			var thisChunkData = resultRows[0];
			var setSqlArr = new Array();
			if (downloading != undefined) {
				setSqlArr.push(' `downloading` = ' + downloading + ' ');
				thisChunkData.downloading = downloading;
			}
			if (isDownloaded != undefined) {
				setSqlArr.push(' `downloaded` = ' + isDownloaded + ' ');
				thisChunkData.downloaded = isDownloaded;
			}
			//alert('UPDATE video_chunk SET ' + setSqlArr.join(',') + ' WHERE ' + where + '');
			if (setSqlArr.length) {
				var sql = 'UPDATE video_chunk SET ' + setSqlArr.join(',') + ' WHERE ' + where + '';
				doQuery(sql, null, function(result){
					callback(byteFrom, byteEnd, noMoreNext, thisChunkData);
				});
			} else {
				callback(byteFrom, byteEnd, noMoreNext, thisChunkData);
			}
			
		} else {
			var thisChunkData = {tid:tid, quality:quality, byte_from:byteFrom, byte_end:byteEnd, downloading:(downloading == undefined?0:downloading), downloaded:(isDownloaded == undefined?0:isDownloaded)};
			var sql = 'INSERT INTO video_chunk (tid, quality, byte_from, byte_end, downloading, `downloaded`) VALUES (' + tid + ', "' + quality + '", ' + byteFrom + ', ' + byteEnd + ', ' + (downloading == undefined?0:downloading) + ', ' + (isDownloaded == undefined?0:isDownloaded) + ')';
			doQuery(sql, null, function(id) {
				callback(byteFrom, byteEnd, noMoreNext, thisChunkData);
			});
		}
	});
}

function getChunkData(tid, quality, extraSql, callback, passingOBJ) {
	var where = ' tid = ' + tid + ' AND quality = "' + quality + '" ';
	if (extraSql != undefined) {
		where += extraSql;
	}
	where += ' ORDER BY byte_from ASC ';
	var sql = 'SELECT * FROM video_chunk WHERE ' + where + '';
	doQuery(sql, null, function(resultRows){
		if (resultRows != null && resultRows != undefined && resultRows.length > 0) {
			callback(resultRows, passingOBJ);
		} else {
			callback(false, passingOBJ);
		}
	});
}

function initChunkData(tid, quality, byteTotal, allUpdateCallback) {
	var byteFrom = 0;
	var statusDOMOnVideoDetailPage = $('#video_download_' + tid + ' .video_repo_download_status[quality=' + quality + ']');
	var statusDOMOnDownloadingPage = $('#downloading_video_item_container_' + tid + ' .dvi_downloading_progress_text');
	var notCompletedChunkData = new Array();
	var ropeCount = 0;
	var totalRopes = Math.ceil(byteTotal / gChunkSize);
	var sql = 'SELECT COUNT(1) AS num FROM video_chunk WHERE tid = ' + tid + ' AND quality = "' + quality + '"';
	doQuery(sql, null, function(resultRows){
		if (resultRows != null && resultRows != undefined && resultRows.length > 0 && parseInt(resultRows[0].num, 10) === totalRopes) {	//碎片在数据库的条目数目对的上
			var statusText = usingLang.download_status_prepared_text1 + totalRopes + '/' + totalRopes + usingLang.download_status_prepared_text2;
			renderVideoDownloadingStatus(tid, quality, statusDOMOnVideoDetailPage, undefined, undefined, statusText);
			statusDOMOnDownloadingPage.html(statusText);
			//不需要完整走一遍数据，只需要取出gChunkDownloadNum条还未下载完成的数据库条目即可
			var sql = 'SELECT * FROM video_chunk WHERE tid = ' + tid + ' AND quality = "' + quality + '" AND downloaded = 0 ORDER BY byte_from ASC';
			doQuery(sql, null, function(resultRows){
				if (resultRows != undefined && resultRows.length) {
					allUpdateCallback(resultRows);
				} else {
					allUpdateCallback(undefined);
				}
			});
		} else {
			//--------刷一遍数据库---------\
			while (byteFrom < byteTotal) {
				var byteEnd = byteFrom + gChunkSize - 1;
				
				updateVideoChunk(tid, quality, byteTotal, byteFrom, byteEnd, undefined, undefined, function (returnByteFrom2, returnByteEnd2, noMoreNext, returnChunkData){
					var statusText = usingLang.download_status_preparing_text1 + ropeCount + '/' + totalRopes + usingLang.download_status_preparing_text2;
					
					renderVideoDownloadingStatus(tid, quality, statusDOMOnVideoDetailPage, undefined, undefined, statusText);
					statusDOMOnDownloadingPage.html(statusText);
					
					if (parseInt(returnChunkData.downloaded, 10) !== 1) {
						notCompletedChunkData.push(returnChunkData);
					}
					if (noMoreNext) {
						//console.log('全部数据库完成，字节数' + returnByteFrom2 + '到' + returnByteEnd2);
						allUpdateCallback(notCompletedChunkData);
					} else {
						//console.log('添加单列数据库完成，字节数' + returnByteFrom2 + '到' + returnByteEnd2);
					}
					ropeCount++;
				});
				byteFrom = byteEnd + 1;
			}
			//--------------------------/
		}
	});
	
	
}

function isChunkAllDone(tid, quality, callback) {
	var sql = 'SELECT `downloaded` FROM video_chunk WHERE tid = ' + tid + ' AND quality = "' + quality + '"';
	doQuery(sql, null, function(resultRows){
		if (resultRows != null && resultRows != undefined && resultRows.length > 0) {
			var allDownloaded = true;
			for (var i in resultRows) {
				if (parseInt(resultRows[i].downloaded, 10) === 0) {
					allDownloaded = false;
					break;
				}
			}
			callback(allDownloaded);
		} else {
			callback(false);
		}
	});
	
}

function deleteChunkData(tid, quality, callback) {
	var sql = 'DELETE FROM video_chunk WHERE tid = ' + tid + ' AND quality = "' + quality + '"';
	doQuery(sql, null, function(result){
		if ((typeof callback) == "function") callback(result);
	});
}


function getNextDownloadableChunkData(tid, quality, callback) {
	var sql = 'SELECT * FROM video_chunk WHERE tid = ' + tid + ' AND quality = "' + quality + '" AND downloading = 0 AND `downloaded` = 0 ORDER BY byte_from ASC LIMIT 1';
	doQuery(sql, null, function(resultRows){
		if (resultRows != null && resultRows != undefined && resultRows.length > 0) {
			callback(resultRows[0]);
		} else {
			callback(false);
		}
	});
}

