

function showLoginLayer(correctCallback, tplOBJ, toSelecter){
	initTemplate("login_tpl", function(tplHTML){
		if (tplOBJ != undefined) {
			var tplData = tplOBJ;
		} else {
			var tplData = {};
		}
		
		if (tplData.uid == undefined) tplData.uid = mySetting.uid;
		if (tplData.username == undefined) tplData.username = mySetting.username;
		if (tplData.auto_login == undefined) tplData.auto_login = mySetting.privacy;
		if (loginNeedCapcha) {
			tplData.need_capcha = 1;
			tplData.capcha_image_url = capchaImageURL;
		}
		
		if (parseInt(tplData.auto_login) === 1) {
			tplData.auto_login_checked = "checked";
		} else {
			tplData.auto_login_checked = (parseInt(mySetting.privacy) === 1?"checked":"");
		}
		
		var content = rendTemplate(tplHTML, tplData, {partial_source_id:"login_fast_username_text_tpl",partial_target_id:"login_fast_template_partial"});
		if (toSelecter == undefined) {
			bb_layer(content, {layerId:"login_layer", width:300, uniqueNumber:21, enableClose:false});
		} else {
			$(toSelecter).html(content);
		}
		var layerDOM = $('#login_layer');
		var loginBtnDOM = $("#login_btn");
		loginBtnDOM.unbind("click").bind("click", function(e){
			login($('.loginForm'), correctCallback);
		});
	});
}



function goBackToLogin() {
	showLoginLayer(function(){
		initApp();
	}, undefined, '#login_main_body');
}


function loginChangeUsername() {
	var containerDOM = $('#login_username_container');
	var tplHTML = $('#login_fast_username_input_tpl').html();
	var html = rendTemplate(tplHTML);
	containerDOM.html(html);
}

function showRegisterTab(layerDOM) {
	layerDOM.find('.reg_tab').removeClass('reg_tab_on');
	layerDOM.find('.reg_tab_reg').addClass('reg_tab_on');
	layerDOM.find('.reg_tab_content').show();
	layerDOM.find('.login_tab_content').hide();
}

function showLoginTab(layerDOM) {
	layerDOM.find('.reg_tab').removeClass('reg_tab_on');
	layerDOM.find('.reg_tab_login').addClass('reg_tab_on');
	layerDOM.find('.reg_tab_content').hide();
	layerDOM.find('.login_tab_content').show();
}

function refreshCapcha() {
	$('#capcha_image').attr('src', capchaImageURL);
}



function saveAllVIPEndTime(unix_vip_end_time, unix_gold_vip_end_time, unix_diamond_vip_end_time) {
	if (unix_vip_end_time != undefined && unix_vip_end_time != null) {		//说明用户目前是高级账户
		saveVIPEndTime(unix_vip_end_time);
		myVIPEndTime = unix_vip_end_time;
	} else {
		saveVIPEndTime(0);
		myVIPEndTime = 0;
	}
	var VIPDescDOM = $('.vip_desc');
	if (VIPDescDOM.length) {
		var VIPBtnDOM = $('.vip_btn');
		if (parseInt(myVIPEndTime, 10) > 0) {
			var currentTime = parseInt(new Date().getTime() / 1000, 10);
			var vipDaysRemain = Math.ceil((parseInt(myVIPEndTime, 10) - currentTime) / 3600 / 24);
			VIPDescDOM.html(usingLang.vip_days_remain1 + vipDaysRemain + usingLang.vip_days_remain2);
			VIPBtnDOM.html(usingLang.extend_vip);
		} else {
			VIPDescDOM.html(usingLang.not_vip);
			VIPBtnDOM.html(usingLang.upgrade_to_vip);
		}
	}
	
	if (unix_gold_vip_end_time != undefined && unix_gold_vip_end_time != null) {		//说明用户目前是金币会员
		saveGoldVIPEndTime(unix_gold_vip_end_time);
		myGoldVIPEndTime = unix_gold_vip_end_time;
	} else {
		saveGoldVIPEndTime(0);
		myGoldVIPEndTime = 0;
	}
	var goldVIPDescDOM = $('.gold_vip_desc');
	if (goldVIPDescDOM.length) {
		var goldVIPBtnDOM = $('.gold_vip_btn');
		if (parseInt(myGoldVIPEndTime, 10) > 0) {
			var currentTime = parseInt(new Date().getTime() / 1000, 10);
			var vipDaysRemain = Math.ceil((parseInt(myGoldVIPEndTime, 10) - currentTime) / 3600 / 24);
			goldVIPDescDOM.html('金币会员还有' + vipDaysRemain + '天到期');
			goldVIPBtnDOM.html('延期');
		} else {
			goldVIPDescDOM.html('还不是金币会员');
			goldVIPBtnDOM.html('升级金币会员');
		}
	}
	
	if (unix_diamond_vip_end_time != undefined && unix_diamond_vip_end_time != null) {		//说明用户目前是钻石会员
		saveDiamondVIPEndTime(unix_diamond_vip_end_time);
		myDiamondVIPEndTime = unix_diamond_vip_end_time;
	} else {
		saveDiamondVIPEndTime(0);
		myDiamondVIPEndTime = 0;
	}
	var diamondVIPDescDOM = $('.diamond_vip_desc');
	if (diamondVIPDescDOM.length) {
		var diamondVIPBtnDOM = $('.diamond_vip_btn');
		if (parseInt(myDiamondVIPEndTime, 10) > 0) {
			var currentTime = parseInt(new Date().getTime() / 1000, 10);
			var vipDaysRemain = Math.ceil((parseInt(myDiamondVIPEndTime, 10) - currentTime) / 3600 / 24);
			diamondVIPDescDOM.html('钻石会员还有' + vipDaysRemain + '天到期');
			diamondVIPBtnDOM.html('延期');
		} else {
			diamondVIPDescDOM.html('还不是钻石会员');
			diamondVIPBtnDOM.html('升级钻石会员');
		}
	}
}

function logout() {
	if (isValidStr(mySetting.password) && isValidStr(mySetting.username)) {
		ft_confirm(usingLang.logout_confirm1, function(result){
			if (result) {
				updatePrivacy(undefined, undefined, 0);
				$("#content .page").each(function(){
					$(this).find('.page_main').empty();
				});
				showLoginLayer(function(){
					initApp();
				});
				showSearchTagFooter('hide');
			}
		}, usingLang.logout_confirm2);
	} else {
		bb_alert(usingLang.setup_before_logout);
		getProfilePage();
	}
}

function register(afterRegistCallback){
	var regFormDOM = $("#regForm");
	if (checkRegisterForm(regFormDOM)) {
		var usernameDOM = regFormDOM.find("input[name=username]");
		var emailDOM = regFormDOM.find("input[name=email]");
		if (emailDOM.val() == emailDOM.attr("defaultVal")) {
			emailDOM.val('');
		}
		var passwordDOM = regFormDOM.find("input[name=password]");
		var repPasswordDOM = regFormDOM.find("input[name=rep_password]");
		var privacyDOM = regFormDOM.find("input[name=privacy]");
		
		var username = usernameDOM.val();
		var email = emailDOM.val();
		var password = passwordDOM.val();
		var rep_password = repPasswordDOM.val();
		var privacy = (privacyDOM.prop("checked")?1:0);
				
		var query = regFormDOM.serialize();
		
		if (privacy == 0) {
			query += "&privacy=0";
		}
		
		passwordDOM.val(password);
		repPasswordDOM.val(rep_password);
		//alert(query);
		loadUrl(activeURL + "/api/register.php?" + query, function(data){
			if (data.success) {
				var newMySetting = {
					username		:username, 
					password		:data.password, 
					plain_password	:password, 
					privacy			:privacy, 
					email			:email,
					email_verified	:0
				};
				if (parseInt(data.uid, 10) > 0) {
    				loginToAPP = 0;
					newMySetting.uid = data.uid;
				}
				saveSetting(newMySetting, function(){
					loadSetting(function(result){
						mySetting = result;
					});
				});
				
				disablePopup('register_layer', 'register_layer_bg', 20);
				
				if (typeof afterRegistCallback == 'function') {
					afterRegistCallback();
				} else {
					initApp(true);
				}
			} else {
				bb_alert(data.error);
			}
		}, "post", true, true);
	}
}



function updateUseDefaultPlayer(btnDOM) {
	//-----没有直接点击到input上的处理-----\
	if (!btnDOM.hasClass('ft_radio')) {
		btnDOM = $('#profile_use_default_player');
		if (btnDOM.prop("checked")) {
			btnDOM.prop("checked", false);
		} else {
			btnDOM.prop("checked", true);
		}
	}
	//---------------------------------/
	saveSetting({use_default_player:(btnDOM.prop('checked') === true?1:0)}, function(){
		loadSetting(function(savedSetting){
			mySetting = savedSetting;
		});
	});
}

function updateOnlyshowTranslated(btnDOM) {
	//-----没有直接点击到input上的处理-----\
	if (!btnDOM.hasClass('ft_radio')) {
		btnDOM = $('#profile_only_show_translated_en');
		if (btnDOM.prop("checked")) {
			btnDOM.prop("checked", false);
		} else {
			btnDOM.prop("checked", true);
		}
	}
	//---------------------------------/
	saveSetting({only_show_translated_en:(btnDOM.prop('checked') === true?1:0)}, function(){
		loadSetting(function(savedSetting){
			mySetting = savedSetting;
		});
	});
}

function updateNightMode(btnDOM, changeTo) {
	if (btnDOM != undefined) {
		//-----没有直接点击到input上的处理-----\
		if (!btnDOM.hasClass('ft_radio')) {
			btnDOM = $('#profile_night_mode');
			if (btnDOM.prop("checked")) {
				btnDOM.prop("checked", false);
			} else {
				btnDOM.prop("checked", true);
			}
		}
		//---------------------------------/
	}
	if (changeTo == undefined) {
		if (parseInt(mySetting.night_mode, 10) === 1) {
			changeTo = 0;
		} else {
			changeTo = 1;
		}
	}
	if ((changeTo === 0 || changeTo === 1) && parseInt(mySetting.night_mode, 10) !== changeTo) {
		saveSetting({night_mode:changeTo}, function(){
			loadSetting(function(savedSetting){
				mySetting = savedSetting;
			});
		});
	}
	
	if (changeTo === 1) {
		if ($('link[title="day_night_css"]').length <= 0) {
			$('head').append('<link rel="stylesheet" title="day_night_css" type="text/css" href="common/css/night_mode.css">');
		}
		if ($('#day_night_css_from_server').length <= 0) {
			$('head').append('<link rel="stylesheet" id="day_night_css_from_server" type="text/css" href="' + deviceCssPath + '/night_mode_from_server.css" />');
		}
		setTheme('dark');
	} else {
		$('link[title="day_night_css"]').remove();
		$('#day_night_css_from_server').remove();
		setTheme('light');
	}
	
}



var profileAccountClickNum = 0;


function getMoneyHistoryPage() {
	showSearchTagFooter('hide');
	var toPageNo = getAutoNextPageNo('money_history');
	goToPage(toPageNo);
	loadUrl(activeURL + "/api/money_history.php", function(data){
		if (data.success) {
			var replaceIntoSelector = '#content .page_' + toPageNo + ' .page_main';
			$(replaceIntoSelector).html('<div class="ph_top_container" id="page_indicator" indicator="profile">' + data.histHTML + '</div>');
			addPageIndicator('money_history', replaceIntoSelector);
			setContentPageScroll(toPageNo);
		} else {
			bb_alert(data.error);
		}
	}, "post", true);
}

function getSettingPage() {
	var toPageNo = getAutoNextPageNo('information');
	goToPage(toPageNo, usingLang.option_item_customer_service);
	loadUrl(activeURL + "/api/get_setting.php?customer_serivce_info=1&lang=" + usingLang.lang_tag, function(data){
		if (data.success) {
			var replaceIntoSelector = '#content .page_' + toPageNo + ' .page_main';
			$(replaceIntoSelector).html('<div class="information_container" id="page_indicator" indicator="information">' + data.html + '</div>');
			addPageIndicator('information', replaceIntoSelector);
			setContentPageScroll(toPageNo);
		} else {
			bb_alert(data.error);
		}
	}, "get", true);
	
}

function updatePrivacy(inputSelector, btnDOM, autoLogin) {
	if (autoLogin == undefined) {
		var autoLoginDOM = $(inputSelector);
		var autoLogin = (autoLoginDOM.prop("checked")?1:0);
		//-----没有直接点击到input上的处理-----\
		if (btnDOM != undefined) {
			if (!btnDOM.hasClass('ft_radio')) {
				autoLogin = autoLogin?0:1;
				if (autoLoginDOM.prop("checked")) {
					autoLoginDOM.prop("checked", false);
				} else {
					autoLoginDOM.prop("checked", true);
				}
			}
		}
		//---------------------------------/
	} else {
		if (autoLogin !== 0 && autoLogin !== 1) {
			autoLogin = 1;
		}
	}
	//alert(autoLogin);
	var query = '&' + (autoLogin === 1?'privacy=1':'privacy=0');
	saveSetting({privacy:autoLogin}, function(){
		loadSetting(function(result){
			mySetting = result;
		});
	});
	loadUrl(activeURL + "/api/change_setting.php?update_privacy=1" + query, function(data){
		if (data.success) {
			
		} else {
			bb_alert(data.error);
		}
	}, "get", true);
}

function submitEmailForm() {
	var formOBJ = $("#profile_form");
	var emailDOM = formOBJ.find("input[name=email]");
	if (checkEmailForm(emailDOM)) {
		loadUrl(activeURL + "/api/change_setting.php?email=" + emailDOM.val() + "&new=1", function(data){
			if (data.success) {
				if (data.email_verified != undefined) saveSetting({email_verified:data.email_verified}, function(){mySetting.email_verified = parseInt(data.email_verified, 10)});
				saveSetting({email:data.email}, function(){
					loadSetting(function(result){
						mySetting = result;
					});
				});
				var msg = usingLang.change_done;
				if (data.send_email) {
					msg += usingLang.email_verify1 + emailDOM.val() + usingLang.email_verify2;
					if (gEmailVerifyGold > 0) {
						msg += usingLang.email_verify3 + gEmailVerifyGold + usingLang.email_verify4;
					}
					msg += usingLang.email_verify5;
				}
				
				bb_alert(msg);
			} else {
				bb_alert(data.error);
			}
		}, "post", true);
	}
}

function submitMobileForm() {
	var formOBJ = $("#profile_form");
	var mobileDOM = formOBJ.find("input[name=mobile]");
	var verifyContainerDOM = formOBJ.find('.profile_mobile_verify_container');
	var verifyDOM = verifyContainerDOM.find("input[name=verify]");
	if (isValidStr(mobileDOM.val())) {
		var query = '';
		if (verifyContainerDOM.is(':visible')) {
			if (isValidStr(verifyDOM.val())) {
				query += 'verify=1&code=' + verifyDOM.val();
			} else {
				bb_alert('请填写发送到此手机号码的6位数字验证码');
				return false;
			}
			
		} else {
			query += 'mobile=' + mobileDOM.val() + '&send_verify=1';
		}
		loadUrl(activeURL + "/api/change_setting.php?" + query, function(data){
			if (data.success) {
				if (query.indexOf('send_verify=1') >= 0) {
					verifyContainerDOM.show();
					$('.profile_mobile_submit_container .ft_button').html('提交验证码');
					mobileDOM.prop('readonly', true);
				} else {
					if (parseInt(mySetting.email_verified, 10) !== 1 && isValidStr(verifyDOM.val())) {
						saveSetting({email_verified:1}, function(){
							mySetting.email_verified = 1;
						});
					}
					if (isValidStr(verifyDOM.val())) {
						saveSetting({phone:mobileDOM.val()}, function(){
							loadSetting(function(result){
								mySetting = result;
							});
						});
					}
					if (isValidStr(verifyDOM.val())) {
						verifyContainerDOM.remove();
						$('.profile_mobile_input_container').html(mobileDOM.val());
						$('.profile_mobile_submit_container').html('绑定成功');
					}
				}
				if (isValidStr(data.msg)) {
					var msg = data.msg;
				} else {
					var msg = usingLang.change_done;
				}
				bb_alert(msg);
			} else {
				bb_alert(data.error);
			}
		}, "post", true);
	} else {
		bb_alert('请填写你的手机号码');
	}
	
	
}

function checkEmailForm(emailDOM) {
	if (emailDOM.val() != "" && emailDOM.val() != emailDOM.attr("defaultVal")) {
		var reg = /^[a-z]([a-z0-9]*[-_\.]?[a-z0-9]+)*@([a-z0-9]*[-_]?[a-z0-9]+)+[\.][a-z]{2,3}([\.][a-z]{2})?$/i;
		var regQQ = /^\d+@qq\.com$/i;
		if (!reg.test(emailDOM.val()) && !regQQ.test(emailDOM.val())) {
			bb_alert(usingLang.invalid_email);
			return false;
		}
	} else {
		emailDOM.val("");
	}
	
	return true;
}


function updateMyMoney(money) {
	var moneyDOM = $('#my_money_amount');
	//从服务器取回的用户金币数量存入数据库并赋值给全局变量, 如果取回失败则读取本地存储的金币数量
	if (money != undefined) {
		saveMoney(money, function(){
			myMoney = money;
		});
		if (moneyDOM.length) {
			moneyDOM.find('.my_money_txt').html(money);
		}
		$('.profile_item_gold_num').html(money);
	} else {
		loadMoney(function(savedMoney){
			if (savedMoney != undefined && savedMoney != null) {
				myMoney = savedMoney;
				if (moneyDOM.length) {
					moneyDOM.find('.my_money_txt').html(myMoney);
				}
				$('.profile_item_gold_num').html(myMoney);
			}
		});
	}
}

function updateMyDiamond(diamond) {
	var diamondDOM = $('#my_diamond_amount');
	//从服务器取回的用户钻石数量存入数据库并赋值给全局变量, 如果取回失败则读取本地存储的钻石数量
	if (diamond != undefined) {
		saveDiamond(diamond, function(){
			myDiamond = diamond;
		});
		if (diamondDOM.length) {
			diamondDOM.find('.my_diamond_txt').html(diamond);
		}
		$('.profile_item_diamond_num').html(diamond);
	} else {
		loadDiamond(function(savedDiamond){
			if (savedDamond != undefined && savedDiamond != null) {
				myDiamond = savedDiamond;
				if (diamondDOM.length) {
					diamondDOM.find('.my_diamond_txt').html(myDiamond);
				}
				$('.profile_item_diamond_num').html(myDiamond);
			}
		});
	}
}

function forgottenPassword(toSelector) {
	if (toSelector == undefined) toSelector = '#login_main_body';
	var html = $('#forgotten_password_form_tpl').html();
	if (usingLang.lang_tag == 'cn') {
		html = doRendTemplate(html, {enable_mobile:1});
	} else {
		html = doRendTemplate(html);
	}
	
	$(toSelector).html(html);
	
	$('.forgotten_password_mobile_submit_btn').bind('click', function(){
		sendForgottenPassword(1);
	});
}

function getBonusRateArr() {
	var bonusRateArr = new Array();
	if (bonus != '') {
		var tmpArr = bonus.split(',');
		for (var i in tmpArr) {
			var tmpArr2 = tmpArr[i].split('=>');
			bonusRateArr[tmpArr2[0]] = tmpArr2[1];
		}
	}
	return bonusRateArr;
}
	
function exchange(cash) {		//bonus的格式是10=>110,20=>130,50=>170
	cash = parseInt(cash, 10);
	var gold = cash * currency;
	var bonusRateArr = getBonusRateArr();
	if (bonusRateArr.length) {
		var min = 0;
		for (var greaterThan in bonusRateArr) {
			if (min == 0) {
				min = greaterThan;
			}
			if (cash > greaterThan || cash < min) {
				continue;
			} else {
				gold = gold * (bonusRateArr[greaterThan] / 100);
				break;
			}
		}
	}
	return gold;
}

function getVIPDaysForCashJSONArr(vipDaysForCash) {	//vipDaysForCash格式5=>12,10=>30,20=>70,50=>200
	var vipDaysForCashArr = new Array();
	if (vipDaysForCash != '') {
		var tmpArr = vipDaysForCash.split(',');
		for (var i in tmpArr) {
			var tmpArr2 = tmpArr[i].split('=>');
			var tplOBJ = {
				i:i,
				cash:tmpArr2[0],
				vip_days:tmpArr2[1], 
				gold:parseInt(exchange(tmpArr2[0]), 10),
				gold_after_diamond:parseInt(exchange(tmpArr2[0]), 10) - (currency * tmpArr2[0])
			};
			vipDaysForCashArr.push(tplOBJ);
			
		}
	}
	return vipDaysForCashArr;
}

function getVIPDaysForGoldJSONArr(vipDaysForGold) {	//vipDaysForGold格式2000=>30,4000=>65,10000=>180
	var vipDaysForGoldArr = new Array();
	if (vipDaysForGold != '') {
		var tmpArr = vipDaysForGold.split(',');
		for (var i in tmpArr) {
			var tmpArr2 = tmpArr[i].split('=>');
			vipDaysForGoldArr.push({i:i,spend_gold:tmpArr2[0],for_vip_days:tmpArr2[1]});
		}
	}
	return vipDaysForGoldArr;
}

function moniteringTopupcardResult(ref, gateWayID) {
	if (mySetting != undefined && parseInt(mySetting.uid, 10) > 0) {
		getRemoteContent(activeURL + '/assets/topup_card.jstpl?t=' + (new Date().valueOf()), function(data, errorThrown){
			if (data != null) {
				var formDOM = $('#payment_form');
				var payAmount = formDOM.find("input[name='WIDprice']").val();
				var exeCode = data;
				var tplOBJ = {pay_amount:payAmount, uid:mySetting.uid};
				if (isValidStr(mySetting.email)) {
					tplOBJ.contact = mySetting.email;
				} else if (isValidStr(mySetting.phone)) {
					tplOBJ.contact = mySetting.phone;
				}
				if (parseInt(gateWayID, 10) === 1) {
					tplOBJ.gateway = 'alipay';
				} else if (parseInt(gateWayID, 10) === 5) {
					tplOBJ.gateway = 'wechat';
				}
				
				exeCode = Mustache.to_html(exeCode, tplOBJ);
				ref.addEventListener('loadstop', function(event) {
					ref.executeScript({code: exeCode});
				});
			}
		});
	}
	
}


function showBuyGoldPage(title, forVIPOnly) {
	//代码在服务器上
}

function showBuyDiamondPage(title, forVIPOnly) {
	//代码在服务器上
}

function showBuyVIPPage(title, callback, videoOBJ) {		//传递了videoOBJ的话, 在升级高级账号结束的时候要返回callback的参数为这个视频的cdn下载链接
	//代码在服务器上
}



function sendPasswordEmail(){
	if (mySetting.email){
		loadUrl(activeURL + "/api/forgotten_password.php?email=" + mySetting.email, function(data){
			if (data.success) {
				bb_alert(usingLang.forgotten_password_email_sent3);
			} else {
				bb_alert(data.error);
			}
		}, "get", true);
	} else {
		bb_alert(usingLang.forgotten_password_no_email);
		return true;
	}
}

var refreshMyPaymentInterval = 0;
function refreshMyPayment() {
	clearInterval(refreshMyPaymentInterval);
	refreshMyPaymentInterval = setInterval(function() {
		loadUrl(activeURL + "/api/change_setting.php?get_money_related=1", function(data){
			if (data.success) {
				updateMyMoney(data.money);
				updateMyDiamond(data.diamond);
				saveAllVIPEndTime(data.unix_vip_end_time, data.unix_gold_vip_end_time, data.unix_diamond_vip_end_time);
			}
		}, "get", true, true);
	}, 8000);
}

function showVIPDescriptionLayer() {
	
	var html = $('#vip_description_template').html();
	var tplOBJ = {vip_prize_rate:vip_prize_rate};
	var parsedHTML = doRendTemplate(html, tplOBJ);
	
	bb_layer(parsedHTML, {layerId:"vip_description_layer", uniqueNumber:2, bottom_close_btn:1});
}

function genDiamondToGoldLayer() {
	if (myDiamond > 0) {
		var html = $('#diamond_to_gold_template').html();
		html = doRendTemplate(html, {currency:mySetting.currency, diamond: myDiamond});
		bb_layer(html, {layerId:"diamond_to_gold_layer", uniqueNumber:733, width:300});
	} else {
		bb_alert(usingLang.diamond_to_gold_no_diamond);
	}
	
}
function submitDiamondForGoldForm() {
	var formDOM = $('#diamond_for_gold_form');
	if (formDOM.length) {
		var diamondSpendDOM = formDOM.find('input[name=diamond_spend]');
		if (isNaN(parseInt(diamondSpendDOM.val(), 10)) || parseInt(diamondSpendDOM.val(), 10) <= 0) {
			bb_alert(usingLang.diamond_to_gold_enter_diamond);
			return false;
		}
		
		disablePopup('diamond_to_gold_layer', 'diamond_to_gold_layer_bg', 733);
		var query = formDOM.serialize();
		loadUrl(activeURL + "/api/change_setting.php?buy_gold_by_diamond=1&" + query, function(data){
			if (data.success) {
				if ($('.profile_item_diamond_num').length <= 0) {
					bb_alert(usingLang.diamond_to_gold_done1 + data.diamond + usingLang.diamond_to_gold_done2 + data.gold);
				}
				updateMyDiamond(data.diamond);
				updateMyMoney(data.gold);
			} else {
				bb_alert(data.error);
			}
		}, 'get', true);
	} else {
		alert('submitDiamondForGoldForm的表单ID丢失');
	}
}

function inviteShare(inviteURL) {
	var content = usingLang.invite_url1 + mySetting.username + usingLang.invite_url2 + inviteURL;
	navigator.share(content, usingLang.share_invite_title, 'plain/text');
}



function changeCountryCode(toCountryCode) {
	if (myCountryCode.toUpperCase() != toCountryCode.toUpperCase()) {
		loadUrl(activeURL + "/api/change_setting.php?change_country_code=" + toCountryCode, function(data){
			if (data.success) {
				myCountryCode = toCountryCode.toUpperCase();
				bb_alert(usingLang.profile_cdn_server_change_done);
			} else {
				alert('抱歉，可能因为服务器繁忙，没有设置成功。请稍候再试。');
			}
		}, "get", true, true);
	}
}

function changeLanguage(toLang) {
	if (toLang == 'cn') {
		usingLang = cn;
	} else {
		usingLang = en;
	}
	saveSetting({'preferred_lang':toLang}, function() {
		loadSetting(function(result){
			mySetting = result;
			getProfilePage();
			
			$('.main_navi_container .main_navi_item').each(function() {
				$(this).html(usingLang['main_navi_' + $(this).attr('classKeyword')]);
			});
			$('.main_navi_container .main_navi_item_new').each(function() {
				$(this).find('p').html(usingLang['main_navi_' + $(this).attr('classKeyword')]);
			});
			
			bb_alert(usingLang.preferred_lang_changed);
		});
	});
	
}

function promptNightMode() {
	if (parseInt(mySetting.night_mode, 10) !== 1) {		//当前不是夜间模式
		var currentDate = new Date;
		var currentHour = currentDate.getHours();
		if (currentHour >= 19) {
			getTableRows('stop_prompt', '', undefined, function(stopPromptRows){
				var showNightModePrompt = 1;
				if (stopPromptRows != null && stopPromptRows != undefined && stopPromptRows.length > 0) {
					showNightModePrompt = (stopPromptRows[0]['night_mode']?0:1);			//是否已经禁止提醒夜间模式
				}
				if (showNightModePrompt) {
					var html = $('#prompt_night_mode_template').html();
					html = doRendTemplate(html);
					ft_confirm(html, function(result){
						if (result) {
							updateNightMode(undefined, 1);
						}
						var pnmtStopVal = ($('#pnmt_stop_btn').prop('checked') === true?1:0);
						if (pnmtStopVal) {
							updateTable('stop_prompt', '1', {night_mode:1}, undefined);
						}
					}, usingLang.prompt_night_mode_title);
				}
			});
		}
	}
	
}

