function getSearchPage() {
	loadSearchPage();
}
function loadSearchPage() {
	var searchPageNo = getAutoNextPageNo('search_tpl');
	goToPage(searchPageNo, usingLang.home_header_search);
	initTemplate("search_tpl", function(tplHTML){
		if (readyForLoadSearchTagArr.length) {
			var tplData = {tag_search_list:readyForLoadSearchTagArr};
			loadSearchSourceType(function(savedSourceType) {
				if (!isValidStr(savedSourceType)) savedSourceType = 'video';
				if (savedSourceType == 'picture') {
					tplData.search_picture_checked = 1;
				} else {
					tplData.search_video_checked = 1;
				}
				if (onlyLoadedTopCate) {
					tplData.only_loaded_top_cate = 1;
				}
				if (!hideAppStoreRelated) {
					tplData.enable_search_video = 1;
				} else {
					tplData.search_picture_checked = 1;
				}
				var replaceIntoSelector = "#content .page_" + searchPageNo + " .page_main";
				var searchHTML = rendTemplate(tplHTML, tplData, {replaceIntoSelector:replaceIntoSelector});
				if (!hideAppStoreRelated) {
					$(replaceIntoSelector + ' .tag_search_appstore_related').show();
				} else {
					$(replaceIntoSelector + ' .tag_search_appstore_related').hide();
				}
				addPageIndicator('search_tpl', replaceIntoSelector);
				
				$('#keyword_search_input').on('keypress', function (e) {
					if (e.which === 13) {
						submitKeywordSearchForm();
					}
			   });
				
				renderSearchTagCate();
				
				var searchTagFooterDOM = $('#search_tag_footer');
				if (searchTagFooterDOM.length) {
					searchTagFooterDOM.remove();
				}
				
				var sTFContainerListOBJArr = [];
				if (gCates.length) {
					for (var i in gCates) {
						sTFContainerListOBJArr.push({id:gCates[i].id});
					}
				}
				var searchTagFooterHTML = $('#search_tag_footer_template').html();
				var tplOBJ = {search_footer_container_list:sTFContainerListOBJArr};
				if (!hideAppStoreRelated) {
					tplOBJ.enable_search_video = 1;
				}
				searchTagFooterHTML = doRendTemplate(searchTagFooterHTML, tplOBJ);
				$('body').append(searchTagFooterHTML);
				if (hideAppStoreRelated) {
					$('#keyword_search_form').find('.ks_source_type').each(function(){
						if ($(this).find('#r54').length) $(this).hide();
						if ($(this).find('#r57').length) $(this).hide();
						if ($(this).find('#r58').length) $(this).hide();
					});
					$('#search_container').find('.search_button_container').hide();
					
				}
				setContentPageScroll(searchPageNo);
			});
			
		} else {
			bb_alert(usingLang.tag_search_wait);
		}
		
	});
}

//-----此函数读取首页的时候就执行了-----\
var readyForLoadSearchTagArr = [];
function initSearchTag() {
	readyForLoadSearchTagArr = [];
	var tmpCates = gCates.slice();		//“真正复制”gCates到tmpCates，因为不希望改变gCates的排序。tmpCates只是用作搜索的时候
	if (tmpCates != undefined && tmpCates.length) {
		for (var i in tmpCates) {
			if (parseInt(tmpCates[i].type, 10) === 1) {		//type=1的顶级分类是有三层的，而搜索的显示结果会少显示一层，造成拍很多二层分类在页面上，会很长。应该把这些太长的分类移动到最下面。这里是通过移动数组顺序实现的。
				var layer1OBJ = tmpCates[i];
				tmpCates.splice(i, 1);
				tmpCates.push(layer1OBJ);
			}
		}
	}
	
	if (tmpCates != undefined && tmpCates.length) {
		for (var i in tmpCates) {
			var layer1OBJ = tmpCates[i];
			if (parseInt(layer1OBJ.type, 10) === 1) {
				
			}
			if (layer1OBJ.has_layer3) {
				if (hasSubcate(layer1OBJ)) {
					for(var x in layer1OBJ.sub_cate) {
						var layer2OBJ = layer1OBJ.sub_cate[x];
						if (findJSON(readyForLoadSearchTagArr, layer2OBJ.id) === null) {
							readyForLoadSearchTagArr.push(layer2OBJ);
						}
						
					}
				}
			} else {
				if (hasSubcate(layer1OBJ)) {
					if (findJSON(readyForLoadSearchTagArr, layer1OBJ.id) === null) {
						readyForLoadSearchTagArr.push(layer1OBJ);
					}
				}
			}
		}
	} else {
		bb_alert(usingLang.tag_search_not_ready);
	}
	tmpCates = undefined;
	//console.log(gCates);
}
//-------------------------/
function renderSearchTagCate() {
	if ($('#search_container').length) {
		if (readyForLoadSearchTagArr.length) {
			$('#tag_search_container').show();
			$('#tag_search_loading').hide();
			var tagCateListHtml = $('#search_tag_cate_tpl').html();
			
			
			for (var i in readyForLoadSearchTagArr) {
				var thisCate = readyForLoadSearchTagArr[i];
				var html = doRendTemplate(tagCateListHtml, {cate_list:thisCate});
				$('.ts_' + thisCate.id + '_tag_container').append(html);				//注意html dom的classname必须有tagKey, 要对应好
			}
			
			showSearchTag();
		} else {
			$('#tag_search_container').hide();
			$('#tag_search_loading').show();
		}
	}
}

function showSearchTag(cateID) {
	var containerDOM = $('#search_container');
	var titleDOM, contentDOM;
	if (cateID != undefined) {
		titleDOM = containerDOM.find('.search_tag_title' + cateID);
		contentDOM = containerDOM.find('.search_tag_content' + cateID);
	}
	
	if (containerDOM.length) {
		if (readyForLoadSearchTagArr.length) {
			if (contentDOM != undefined && contentDOM.find('.search_tag_item').length) {		//分类下的标签DOM已经生成了
				if (contentDOM.is(':visible')) {
					contentDOM.hide();
					if (titleDOM.length) {
						titleDOM.find('span').html('&wedge;');
					}
				} else {
					contentDOM.show();
					if (titleDOM.length) {
						titleDOM.find('span').html('&vee;');
					}
				}
				
			} else {		//没有DOM, 生成html
				var localTagTitlePicArr = [];
				var tagListHtml = $('#search_tag_tpl').html();
				for (var i in readyForLoadSearchTagArr) {
					var thisTags = undefined;
					if (cateID == undefined) {			//默认情况下只显示第一个分类
						if (i == 0) {
							thisTags = readyForLoadSearchTagArr[i].sub_cate;
							cateID = readyForLoadSearchTagArr[i].id;
							titleDOM = containerDOM.find('.search_tag_title' + cateID);
							titleDOM.find('span').html('&vee;');
							contentDOM = containerDOM.find('.search_tag_content' + cateID);
						} else {
							titleDOM = containerDOM.find('.search_tag_title' + cateID);
							titleDOM.find('span').html('&wedge;');
						}
					} else {							//或者显示指定分类
						if (readyForLoadSearchTagArr[i].id == cateID) {
							thisTags = readyForLoadSearchTagArr[i].sub_cate;
							titleDOM = containerDOM.find('.search_tag_title' + cateID);
							titleDOM.find('span').html('&vee;');
						}
					}
					
					if (thisTags && thisTags != undefined && thisTags != null && thisTags.length) {
						var tagTPLOBJ = new Array();
						for (var y in thisTags) {
							var thisTag = thisTags[y];
							//--------格式化标签的视频数量--------\
							thisTags[y].show_video_num = formatTagMediaNum(thisTag.video_num);
							//--------------------------------/
							//--------格式化标签的图片数量--------\
							thisTags[y].show_pic_num = formatTagMediaNum(thisTag.pic_num);
							//--------------------------------/
							//-------不显示视频和图片数量都为0的标签--------\
							if (parseInt(thisTag.pic_num, 10) > 0 || parseInt(thisTag.video_num, 10) > 0) {
								tagTPLOBJ.push(thisTags[y]);
							}
							//-----------------------------------------/
							if (isValidStr(thisTag.title_pic)) {
								localTagTitlePicArr.push({
									selector: "#search_tag_title_pic_" + thisTag.id, 
									url: thisTag.title_pic
								});
							}
						}
						var html = doRendTemplate(tagListHtml, {tags:tagTPLOBJ});
						contentDOM.append(html);
						if (!hideAppStoreRelated) {
							contentDOM.find('.tag_search_appstore_related').show();
						} else {
							contentDOM.find('.tag_search_appstore_related').hide();
						}
					}
					
					
				}
			}
			
			if (localTagTitlePicArr.length) {
				renderLocalImage(localTagTitlePicArr, "tag/picture", "src", function(){}, function(){});
			}
			
		}
	}
}

function formatTagMediaNum(num) {
	var formatNum = parseInt(num, 10);
	if (formatNum > 999) {
		formatNum = Math.floor(formatNum / 1000) + 'K+';
	}
	return formatNum;
}

function selectSearchTag(tagID, btnDOM) {
	var imgDOM = btnDOM.find('.home_btn_item_img');
	if (imgDOM.hasClass('home_btn_item_img_on')) {
		imgDOM.removeClass('home_btn_item_img_on');
	} else {
		imgDOM.addClass('home_btn_item_img_on');
	}
	
	renderSearchTagFooterTxt(btnDOM);
	
	showSearchTagFooter();
	
	addValueTosearchTagForm(tagID, btnDOM);
}

function addValueTosearchTagForm(tagID, tagDOM) {
	var formDOM = $('#tag_search_form');
	var tagInputDOM = formDOM.find('#search_tag_input_' + tagID);
	if (tagInputDOM.length) {
		tagInputDOM.remove();
	} else {
		var inputName = '';
		inputName = 'tag_id[]';
		var html = "<input type='hidden' id='search_tag_input_" + tagID + "' name='" + inputName + "' value='" + tagID + "' />";
		formDOM.prepend(html);
	}
}

function submitSearchTagForm(searchMedia) {
	if (searchMedia == 'pic') {
		var title = $('.search_tag_selected_txt').text();
		title = title.replace(/[+]/g, '');
		getGalleryPics("#tag_search_form", {reload:1, title:title});
	} else {
		getGalleryVideos('#tag_search_form', {reload:1, title:title}); 
	}
	initSearchForm();
}



function initSearchForm() {
	//-----------将标签搜索表单的所有选中标签修改为未选中-----------------\
	var containerDOM = $('#tag_search_container');
	var selectedTagDOM = containerDOM.find('.home_btn_item_img_on');
	if (selectedTagDOM.length) {
		selectedTagDOM.each(function(){
			$(this).removeClass('home_btn_item_img_on');
		});
	}
	containerDOM.find("input[name='tag_id[]']").remove();
	//-----------------------------------------------------------/
	
	//----------将文字框重置为默认------------\
	var keywordDOM = $('#keyword_search_form').find('.ks_input');
	keywordDOM.val(keywordDOM.attr('defaultVal'));
	//------------------------------------/
}

function showSearchTagFooter(act) {
	var containerDOM = $('#tag_search_container');
	var footDOM = $('#search_tag_footer');
	
	if (act == undefined) {
		var selectedTagDOM = containerDOM.find('.home_btn_item_img_on');
		if (selectedTagDOM.length) {
			footDOM.removeClass('search_tag_foot_slide_out').addClass('search_tag_foot_slide_in');
		} else {
			footDOM.removeClass('search_tag_foot_slide_in').addClass('search_tag_foot_slide_out');
		}
	} else {
		if (act == 'show') {
			footDOM.removeClass('search_tag_foot_slide_out').addClass('search_tag_foot_slide_in');
		} else {
			if (isSearchTagFootShowing(footDOM)) {
				setTimeout(function(){
					initSearchTagFooter();
				}, 700);
				footDOM.removeClass('search_tag_foot_slide_in').addClass('search_tag_foot_slide_out');
			}
		}
	}
}

function initSearchTagFooter() {
	var footDOM = $('#search_tag_footer');
	var footTxtDOM = footDOM.find('.stf_container');
	var footPlusDOM = footDOM.find('.stf_plus');
	
	footTxtDOM.html('');
	footPlusDOM.hide();
}

function isSearchTagFootShowing(footerDOM) {
	var footerMovedPix = getTranslateY(footerDOM);
	if (footerMovedPix < 0) {			//显示中
		return true;
	} else {
		return false;
	}
}

function renderSearchTagFooterTxt(tagDOM) {
	var footDOM = $('#search_tag_footer');
	var footTxtDOM = footDOM.find('.search_tag_selected_txt');
	
	var selectingTopCateID = tagDOM.attr('topCateID');
	var selectingTagTxtDOM = tagDOM.find('.home_btn_item_txt');
	var selectingTagTxt = selectingTagTxtDOM.html();
	
	var intoDOM = footTxtDOM.find('.stf_' + selectingTopCateID);
	var existedTxt = intoDOM.html();
	if (isValidStr(existedTxt) && existedTxt != '&nbsp;' && existedTxt != ',' && existedTxt != ',,') {
		existedTxt = existedTxt.substr(1);		//去掉开始和结束的[]符号
		existedTxt = existedTxt.substr(0, existedTxt.length - 1);
		if (existedTxt.indexOf(selectingTagTxt) == -1) {
			intoDOM.html('[' + existedTxt + "," + selectingTagTxt + ']');
		} else {
			existedTxt = existedTxt.replace(',' + selectingTagTxt, '');
			existedTxt = existedTxt.replace(selectingTagTxt + ',', '');
			existedTxt = existedTxt.replace(selectingTagTxt, '');
			if (isValidStr(existedTxt)) {
				intoDOM.html('[' + existedTxt + ']');
			} else {
				intoDOM.html('');
			}
			
		}
	} else {
		intoDOM.html('[' + selectingTagTxt + ']');
	}
	//----判断左右两边有没有文字, 哪边有就在那边显示加号---\
	var leftPlusDOM = intoDOM.prev();
	var rightPlusDOM = intoDOM.next();
	
	var prevAllDOM = intoDOM.prevAll();
	var hasLeft = 0;
	prevAllDOM.each(function(){
		if ($(this).hasClass('stf_container') && isValidStr($(this).html())) {
			hasLeft = 1;
		}
	});
	
	if (leftPlusDOM && leftPlusDOM.length) {
		if (hasLeft) {
			leftPlusDOM.show();
		} else {
			leftPlusDOM.hide();
		}
	}
	
	var nextAllDOM = intoDOM.nextAll();
	var hasRight = 0;
	nextAllDOM.each(function(){
		if ($(this).hasClass('stf_container') && isValidStr($(this).html())) {
			hasRight = 1;
		}
	});
	
	if (rightPlusDOM && rightPlusDOM.length) {
		if (hasRight) {
			rightPlusDOM.show();
		} else {
			rightPlusDOM.hide();
		}
	}
	
	if (!isValidStr(intoDOM.html())) {
		if (leftPlusDOM && leftPlusDOM.length) leftPlusDOM.hide();
		if (rightPlusDOM && rightPlusDOM.length) rightPlusDOM.hide();
	}
	//--------------------------------------------/
	
}





